<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	int libPlateId = Values.getInt(request.getParameter("bioplate"));
	String poolSchema = request.getParameter("poolSchema");
	String barcodeVariant = request.getParameter("barcodeVariant");
	
	BioPlate plate = BioPlate.getById(dc, libPlateId);
	int columns = plate.getColumns();
	int rows = plate.getRows();
	String view = Values.getString(request.getParameter("view"), "list");
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>Lab protocol for <%=HTML.encodeTags(plate.getName())%> - <%=view.equals("list") ? "list" : "table"%></title>
	<link rel="SHORTCUT ICON" href="<%=home%>/images/libprep.png">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/reggie.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/plate.css">
	<script language="JavaScript" src="<%=root%>/include/scripts/main.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=root%>/include/scripts/ajax.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="<%=home %>/reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="pools.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="plate.js" type="text/javascript" charset="UTF-8"></script>
	
	<script language="JavaScript">
	var debug = false;
	var currentStep = 1;
	
	function init()
	{
		var schema = PoolSchema.getById('<%=poolSchema%>');
		var barcodeVariant = PoolSchema.getBarcodeVariantByName(schema, '<%=barcodeVariant%>');

		// Load Libraries and related info from the selected bioplate
		var request = Ajax.getXmlHttpRequest();
		try
		{
			showLoadingAnimation('Loading Library bioplate information...');
			var url = '../LibPrep.servlet?ID=<%=ID%>&cmd=GetLibraryInfoForPlate&bioplate=<%=libPlateId%>';		
			request.open("GET", url, false);
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}
		
		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		
		var list = response.libraries;

		// Pre-process the Library items
		for (var i = 0; i < list.length; i++)
		{
			checkAndPreProcessLibrary(list[i], schema, barcodeVariant);
		}
		
		<%
		if (view.equals("list"))
		{
			%>
			viewAsList(list, schema, barcodeVariant);
			<%
		}
		else
		{
			%>
			viewAsPlate(list, schema, barcodeVariant)
			<%
		}
		%>
	}
	
	function checkAndPreProcessLibrary(lib, schema, barcodeVariant)
	{
		var well = lib.bioWell;
		var remarks = [];

		// Check if default barcode has been modified
		var indexSet = barcodeVariant.indexSets[well.column];
		if (indexSet)
		{
			var defaultBarcode = indexSet.barcodes[well.row];
			if (defaultBarcode && lib.barcode.name != defaultBarcode)
			{
				remarks[remarks.length] = 'Modified barcode';
				lib.barcode.modified = true;
			}
		}
		lib.remarks = remarks;
	}
	
	/**
		Get the plate coordinate string for a well, optionally including the plate
		name or not.
	*/
	function getPlateCoordinate(well, includePlateName)
	{
		var c = '';
		if (well)
		{
			if (includePlateName) c += well.bioPlate.name;
			c += ' ' + WELL_ALPHA[well.row] + (well.column+1);
		}
		return c;
	}
	
	
	function viewAsList(list, schema, barcodeVariant)
	{
		var lastPoolNum = -1;
		for (var i = 0; i < list.length; i++)
		{
			var lib = list[i];
			var well = lib.bioWell;
	
			var idSuffix = well.column + '.' + well.row;
			Main.removeClass(document.getElementById('row.'+idSuffix), 'empty');
			setInnerHTML('lib.'+idSuffix, lib.name);
			setInnerHTML('barcode.'+idSuffix, lib.barcode.name);
			
			var indexSet = barcodeVariant.indexSets[well.column];
			if (indexSet)
			{
				var color = lib.barcode.modified ? 'bg-modified' : indexSet.color;
				Main.addClass(document.getElementById('barcode.'+idSuffix), color);
			}
			
			setInnerHTML('remarks.'+idSuffix, lib.remarks.join('; '));
		}
		Main.show('listviewcontainer');
	}
	
	
	function viewAsPlate(list, schema, barcodeVariant)
	{
		Plate.init(<%=rows%>, <%=columns%>, schema, WellPainter);
		
		for (var i = 0; i < list.length; i++)
		{
			var lib = list[i];
			var well = lib.bioWell;
			Plate.getWell(well.row, well.column).setExtract(lib);
		}

		WellPainter.barcodeVariant = barcodeVariant;
		Plate.paint(Plate.getWells());
		PoolSchema.buildPoolTableRow(schema, <%=columns%>);
		Main.show('plateviewcontainer');
	}

	var WellPainter = function()
	{
		var painter = {};
		
		painter.getClassNameForWell = function(well, schema)
		{
			var cls = '';
			var indexSet = painter.barcodeVariant.indexSets[well.column];
			if (indexSet)
			{
				var lib = well.extract;
				cls += lib && lib.barcode.modified ? 'bg-modified' : indexSet.color;
			}
			return cls;
		}
		
		painter.getWellText = function(well, schema)
		{
			var text = '';
			var lib = well.extract;
			if (lib)
			{
				var name = lib.name;
				var i = name.indexOf('.m');
				text += '<div class="lib">'+name.substring(0, i)+'.<br>&nbsp;'+name.substring(i)+'</div>';
				text += '<div class="barcode">'+lib.barcode.name+'</div>';
				text += '<div class="remarks">'+ lib.remarks.join('; ') + '</div>';
			}
			return text;
		}

		return painter;
	}();
	</script>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	#listview
	{
		width: 100%;
		font-size: 85%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	#listview tr.evencol
	{
		background-color: #F0F0F0;
	}
	
	#listview thead
	{
		border: 1px solid #000000;
		background-color: #F0F0F0;
	}
	
	#listview tbody
	{
		page-break-inside: avoid;
		border-top: 1px solid #000000;
		border-bottom: 1px solid #000000;
	}
	
	#listview th
	{
		border-left: 1px solid #000000;
	}
	
	#listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
	}
	
	#listview .col-num
	{
		width: 1.75em;
		text-align: center;
		font-size: 125%;
		font-weight: bold;
		vertical-align: top;
	}
	
	#listview .lib
	{
		width: 15em;
		text-align: center;
	}
	
	#listview .empty .lib
	{
		font-style: italic;
		color: #666666;
		text-align: center;
	}
	
	#listview .workplate, #listview .barcode
	{
		width: 7em;
		text-align: center;
	}
	#listview .remarks
	{
		vertical-align: top;
		padding-left: 0.25em;
	}
	
	/* Divide the 12 wells across the full page */
	#plateview .well
	{
		width: 8.2%;
		max-width: 8.2%;
		min-width: 8.2%;
		padding: 4px;
	}
	
	#plateview .well:hover
	{
		padding: 3px;
	}
		
	#plateview .rowheader
	{
		width: 2em;
	}
	
	#plateview .lib
	{
		font-weight: bold;
		margin-bottom: 0.25em;
	}
	#plateview .remarks
	{
		color: #C80000;
		font-style: italic;
	}
	</style>
</head>
<body onload="init()">
	<div class="paper <%=view.equals("list") ? "" : "landscape"%>">
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<span class="button" onclick="window.print()" style="float: left; margin-right: 1em;">
			<img src="../images/print.png">Print&hellip;
		</span>
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>landscape</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		<br clear="all">
	</div>
	
	<h1>Lab protocol for library preparation <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr style="border-bottom: 1px solid #000000;">
		<th style="width: 15%;">Work plate</th>
		<td style="width: 30%; border-right: 1px solid #000000;"><%=HTML.encodeTags(plate.getName())%></td>
		<th style="width: 15%;">LibPrep</th>
		<th style="width: 20%;">Date</th>
		<th style="width: 20%;">Operator</th>
	</tr>
	<tr>
		<td rowspan="2" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=HTML.niceFormat(plate.getDescription()) %></td>
		<td style="border-right: 1px solid #000000;">Amplification</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	<tr style="border-top: 1px solid #CCCCCC;">
		<td style="border-right: 1px solid #000000;">Cleanup</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	</table>

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	<div class="messagecontainer error" id="errorMessage" style="display: none;"></div>
	<%
	if (view.equals("list"))
	{
		%>
		<div id="listviewcontainer" style="display: none;">
		<table style="width: 100%;" id="listview">
		<thead>
			<tr class="toprow">
				<th></th>
				<th class="lib"></th>
				<th class="workplate">Work</th>
				<th class="barcode">TruSeq</th>
				<th></th>
			</tr>
			<tr>
				<th></th>
				<th class="lib">Library</th>
				<th class="workplate">plate</th>
				<th class="barcode">index</th>
				<th>Remarks</th>
			</tr>
		</thead>
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		for (int c = 0; c < columns; ++c)
		{
			String rowClass = c % 2 == 0 ? "evencol" : "oddcol";
			%>
			<tbody>
			<%
			for (int r = 0; r < rows; ++r)
			{
				String idSuffix = c + "." + r;
				%>
				<tr class="<%=rowClass%> empty" id="row.<%=idSuffix%>">
					<%
					if (r == 0)
					{
						%>
						<td class="col-num" rowspan="<%=rows%>"><%=c+1%></td>
						<%
					}
					%>
					<td class="lib" id="lib.<%=idSuffix%>">empty</td>
					<td class="workplate"><%=rowF.format(r)+colF.format(c)%></td>
					<td class="barcode" id="barcode.<%=idSuffix%>"></td>
					<td class="remarks" id="remarks.<%=idSuffix%>"></td>
				</tr>
				<%
			}
			%>
			</tbody>
			<%
		}
		%>
		</table>
		</div>
		<%
	}
	else
	{
		%>
		<div id="plateviewcontainer" style="display: none;">
		<table class="plate" style="margin: 0em 0 0 0; width: 100%;" id="plateview">
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		%>
		<tr class="header">
			<th></th>
			<%
			for (int c = 0; c < columns; ++c)
			{
				%>
				<th id="col.<%=c%>"><%=colF.format(c)%></th>
				<%
			}
			%>
		</tr>
		<tbody>
		<%
		for (int r = 0; r < rows; ++r)
		{
			String row = rowF.format(r);
			%>
			<tr class="row-<%=r%>">
				<th id="row.<%=r%>" class="rowheader"><%=row%></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"></td>
					<%
				}
				%>
			</tr>
			<%
		}
		%>
		</tbody>
		<tr id="pool-row">
			<th colspan="13">&nbsp;</th>
		</tr>
		</table>
		</div>
		<%
	}
	%>
	</div>
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>