<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyyMMdd").format(new Date());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

var paraffinBlock;
var existingNumberOfHEGlass = 0;
var stainDateIsValid = false;
var numHEGlassIsValid = false;

function init()
{
	var frm = document.forms['reggie'];

	var plates = getParaffinBlocks();
	
	var plateList = frm.plates;
	if (plates != null && plates.length > 0)
	{
		for (var i=0; i < plates.length; i++)
		{
			var plate = plates[i];
			var option = new Option(plate.name, plate.id);
			option.plate = plate;
			plateList.options[plateList.length] = option;
		}
	}
	else
	{	
		setInputStatus('plates','No paraffin blocks could be found.', 'invalid')
	}
	
	var stainingProtocols = getProtocols('STAINING_PROTOCOL');
	for (var i = 0; i < stainingProtocols.length; i++)
	{
		var protocol = stainingProtocols[i];
		var option = new Option(protocol.name, protocol.id, protocol.isDefault);
		frm.stainingProtocol[frm.stainingProtocol.length] = option;		
	}
	if (frm.stainingProtocol.length == 0)
	{
		frm.stainingProtocol[0] = new Option('- none -', '');
	}
	
	Main.show('gonext');
}

function getParaffinBlocks()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading paraffin blocks...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=GetParaffinBlocks';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.plates;
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}


function selectParaffinBlocks()
{
	var frm = document.forms['reggie'];
	if (frm.plates.disabled) return;
	
	var url = getRoot() + 'biomaterials/bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setParaffinBlockCallback';
	url += '&tmpfilter:STRING:bioPlateType.name=FFPE+block';
	url += '&tmpfilter:INT:freeWells=1';
	url += '&resetTemporary=1';
	Main.openPopup(url, 'SelectParaffinBlocks', 1050, 700);
}

function setParaffinBlockCallback(id, name)
{
	var frm = document.forms['reggie'];
	var plates = frm.plates;
	for (var i = 0; i < plates.length; i++)
	{
		if (plates[i].value == id)
		{
			plates[i].selected = true;
			return;
		}
	}

	var option = new Option(name, id, true, true);
	plates[plates.length] = option;
}


function step1IsValid()
{
	var frm = document.forms['reggie'];
	var plates = frm.plates;
	var selectedPlates = new Array();
	for (var i=0; i < plates.length; i++)
	{
		if (plates[i].selected)
		{
			selectedPlates[selectedPlates.length] = plates[i].value;
		}
	}
	
	if (selectedPlates.length == 0)
	{
		setInputStatus('plates', 'Not selected', 'invalid');
		return false;
	}
	
	setInputStatus('plates', '', 'valid');

	return true;
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	Main.hide('navigation');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	else if (currentStep == 2)
	{
		gotoStep3();
	}
	Main.show('navigation');
}


function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	var selectedPlateId =  frm.plates[frm.plates.selectedIndex].value;
	
	frm.plates.disabled = true;
	currentStep = 2;
	
	Main.show('gocancel');
	Main.show('step2');

	paraffinBlock = getParaffinBlockInfo(selectedPlateId);
	if (!paraffinBlock) return;
	
	var heGlass = paraffinBlock.heGlass;
	var wellMap = [1, 0, 3, 2, 5, 4]; // Map well on Paraffin block to well on HEglass
	
	setInnerHTML('blockName', paraffinBlock.name);
	frm.comment.value = paraffinBlock.comment;
	if (heGlass) 
	{
		frm.numberOfHEGlass.value = heGlass.length;
		existingNumberOfHEGlass = heGlass.length;
	}
	
	var numWells = 0;
	for (var i = 0; i < paraffinBlock.bioWells.length; i++)
	{
		var well = paraffinBlock.bioWells[i];
		var div = document.getElementById('his.' + well.row + '.' + well.column);
		if (div && well.bioMaterial)
		{
			div.innerHTML = well.bioMaterial.name;

			if (heGlass)
			{
				
				setInnerHTML('existingGlass', '<img src="../images/info.png">There are ' + heGlass.length + ' HE glass plates already registered for this paraffin block.');
				Main.show('existingGlass');
				
				// Try to find the current "GoodStain" annotation on a child biomaterial
				for (var j = 0; j < heGlass.length; j++)
				{
					var heWell = heGlass[j].bioWells[wellMap[i]];
					if (heWell.bioMaterial && heWell.bioMaterial.GoodStain)
					{
						var field = 'idx.'+well.row + '.' + well.column;
						frm[field].value = j+1;
						checkIndexValue(field);
						break;
					}
				}
			}

			numWells++;
		}
	
	}
	
	if (numWells != 5)
	{
		setFatalError('Could not find 5 histology items on the paraffin block.');
		return;
	}
	
	stainDateOnChange();
	frm['numberOfHEGlass'].focus();
}

function getParaffinBlockInfo(plateId)
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading paraffin block information...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=GetParaffinBlockInfo&bioPlateId='+plateId;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return null;
	}
	return response.paraffinBlock;
}

function stainDateOnChange()
{
	var frm = document.forms['reggie'];
	stainDateIsValid = false;
	setInputStatus('stainDate', '', '');
	
	var stainDate = frm.stainDate.value;
	
	if (stainDate == '')
	{
		setInputStatus('stainDate', 'Missing', 'warning');
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
		stainDate = autoFillDate(stainDate);
		frm.stainDate.value = stainDate;
	
		if (!Dates.isDate(stainDate, 'yyyyMMdd'))
		{
			setInputStatus('stainDate', 'Not a valid date', 'invalid');
			return;
		}
		setInputStatus('stainDate', '', 'valid');
	}
	
	stainDateIsValid = true;
}

var wells = ['idx.0.0', 'idx.1.0', 'idx.1.1', 'idx.2.0', 'idx.2.1'];
function step2IsValid()
{
	var frm = document.forms['reggie'];
	if (!numHEGlassIsValid)
	{
		frm.numberOfHEGlass.focus();
		return false;
	}
	
	var numHEGlass = parseInt(frm.numberOfHEGlass.value, 10);
	var allValid = true;
	for (var i = 0; i < wells.length; i++)
	{
		var field = frm[wells[i]];
		var indexValue = parseInt(field.value, 10);
		if (!indexValue || indexValue <= 0 || indexValue > numHEGlass)
		{
			setInputStatus(field.name, null, 'invalid');
			if (allValid) field.focus(); // Set focus to first invalid field
			allValid = false;
		}
		else
		{
			setInputStatus(field.name, null, 'valid');
		}
	}
	
	if (!allValid)
	{
		setInputStatus('index', 'Value must be between 1–' + numHEGlass, 'invalid');
		return false;
	}
	
	if (!stainDateIsValid)
	{
		return false;
	}
	
	setInputStatus('index', '', '');
	return true;
}

function checkIndexValue(field)
{
	var frm = document.forms['reggie'];
	
	var numHEGlass = parseInt(frm.numberOfHEGlass.value, 10) || 1;
	var indexValue = parseInt(frm[field].value, 10);

	if (!indexValue || indexValue <= 0 || indexValue > numHEGlass)
	{
		setInputStatus(field, null, 'invalid');
		setInputStatus('index', 'Must be between 1–'+numHEGlass, '');
		return;
	}

	setInputStatus(field, null, 'valid');
	setInputStatus('index', '', '');
}

function checkNumHEGlass()
{
	var frm = document.forms['reggie'];
	numHEGlassIsValid = false;
	
	var numHEGlass = parseInt(frm.numberOfHEGlass.value, 10) || 0;
	var limit = Math.max(1, existingNumberOfHEGlass);
	if (numHEGlass < limit)
	{
		setInputStatus('numberOfHEGlass', 'Must be a value &gt;= ' + limit, 'invalid');
		return;
	}
	
	setInputStatus('numberOfHEGlass', '', 'valid');
	numHEGlassIsValid = true;
	
	for (var i = 0; i < wells.length; i++)
	{
		checkIndexValue(wells[i]);
	}

}

function gotoStep3()
{
	if (!step2IsValid()) return;

	var frm = document.forms['reggie'];
	frm.stainDate.disabled = true;
	frm.stainingProtocol.disabled = true;
	frm.comment.disabled = true;
	frm.numberOfHEGlass.disabled = true;
	
	var numHEGlass = parseInt(frm.numberOfHEGlass.value, 10);
	for (var i = 0; i < wells.length; i++)
	{
		var field = frm[wells[i]];
		field.disabled = true;
	}

	var lastHeGlassPosition = getLastUsedHeGlassPosition();
	
	currentStep = 3;
	Main.hide('gonext');
	Main.show('gocreate');
	Main.show('glassBoxSection');
		
	var html = '<table id="glassTable">';
	html += '<thead>';
	// First header row
	html += '<tr>';
	html += '<th>HE glass</th>';
	html += '<th>Storage box</th>';
	html += '<th>Position</th>';
	html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
	
	var glassNamePrefix = paraffinBlock.name.replace('PB', 'HE');
	var heGlass = paraffinBlock.heGlass;
	
	for (var glassNo = 0; glassNo < numHEGlass; glassNo++)
	{
		var nextStep = glassNo < (numHEGlass-1) ? 'focusOnEnter(event, \'glassBox'+(glassNo+1)+'\');' : '';
		var heSlide = new Object();
		
		if (heGlass && heGlass[glassNo])
		{
			heSlide = heGlass[glassNo];
		}
		else
		{
			heSlide.name = glassNamePrefix + '.' + (glassNo+1);
		}
		if (!heSlide.position)
		{
			if (lastHeGlassPosition && lastHeGlassPosition.position)
			{
				heSlide.position = ++lastHeGlassPosition.position;
				if (heSlide.position > 100)
				{
					heSlide.position = 1;
					lastHeGlassPosition.position = 1;
					lastHeGlassPosition.storageBox++;
				}
				heSlide.storageBox = lastHeGlassPosition.storageBox;
			}
			else
			{
				heSlide.position = '';
				heSlide.storageBox = '';
			}
		}

		html += '<tr style="border-top: 1px dotted #A0A0A0;">';
		html += '<td style="width: 120px;">' + heSlide.name + '</td>';
		html += '<td><input type="text" name="glassBox'+glassNo+'" value="'+heSlide.storageBox+'" onblur="glassBoxOnChange('+glassNo+')"';
		html += ' onkeypress="focusOnEnter(event, \'position'+glassNo+'\'); return Numbers.integerOnly(event)" size="10" ></td>';
		html += '<td><input type="text" name="position'+glassNo+'" value="'+heSlide.position+'" onblur="glassBoxOnChange('+glassNo+')"';
		html += ' onkeypress="'+nextStep+' return Numbers.integerOnly(event)" size="10" ></td>';
		html += '<td class="status" id="glassBox'+glassNo+'.status"></td>';
		html += '</tr>';
		
		html += '<tr>';
		html += '<td style="width: 120px;" class="subprompt">- comment</td>';
		html += '<td colspan="2"><input type="text" name="comment'+glassNo+'" value="" style="width: 100%;"></td>';
		html += '<td class="status"></td>';
		html += '</tr>';
	}
	html += '</tbody>';
	html += '</table>';
	setInnerHTML('glassBoxInput', html);
	
	for (var glassNo = 0; glassNo < numHEGlass; glassNo++)
	{
		if (heGlass && heGlass[glassNo])
		{
			frm['comment'+glassNo].value = heGlass[glassNo].comment;
			glassBoxOnChange(glassNo);
		}
		else
		{
			setInputStatus('glassBox'+glassNo, null, 'new');
		}
	}
	
	frm.glassBox0.focus();
}


function glassBoxOnChange(glassNo)
{
	var frm = document.forms['reggie'];
	if (frm['glassBox'+glassNo].value == '')
	{
		setInputStatus('glassBox'+glassNo, 'Missing storage box', 'invalid');
		return;
	}
	if (frm['position'+glassNo].value == '')
	{
		setInputStatus('glassBox'+glassNo, 'Missing position', 'invalid');
		return;
	}
	
	setInputStatus('glassBox'+glassNo, null, 'valid');
}

function getLastUsedHeGlassPosition()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading HE glass information...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=FindLastUsedHeGlassPosition';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return null;
	}
	return response;
}


function step3IsValid()
{
	var glassNo = 0;
	var frm = document.forms['reggie'];
	while (frm['glassBox'+glassNo])
	{
		if (frm['glassBox'+glassNo].value == '')
		{
			frm['glassBox'+glassNo].focus();
			return false;
		}
		if (frm['position'+glassNo].value == '')
		{
			frm['position'+glassNo].focus();
			return false;
		}
		glassNo++;
	}
	return true;
}

function goCreate()
{
	if (!step3IsValid()) return;

	Main.hide('gocreate');
	Main.hide('gocancel');

	var frm = document.forms['reggie'];
	
	for (var i = 0; i < paraffinBlock.bioWells.length; i++)
	{
		var well = paraffinBlock.bioWells[i];
		var field = 'idx.'+ well.row + '.' + well.column;
		if (frm[field])
		{
			well.GoodStain = parseInt(frm[field].value, 10);
		}
	}
	
	if (!paraffinBlock.heGlass) paraffinBlock.heGlass = new Array();
	
	var glassNo = 0;
	while (frm['glassBox'+glassNo])
	{
		if (paraffinBlock.heGlass.length <= glassNo)
		{
			paraffinBlock.heGlass[glassNo] = new Object();
		}
		var heGlass = paraffinBlock.heGlass[glassNo];
		heGlass.storageBox = frm['glassBox'+glassNo].value;
		heGlass.position = frm['position'+glassNo].value;
		heGlass.comment = frm['comment'+glassNo].value;
		glassNo++;
	}
	
	var submitInfo = new Object();
	paraffinBlock.stainDate = frm.stainDate.value;
	paraffinBlock.protocolId = parseInt(frm.stainingProtocol[frm.stainingProtocol.selectedIndex].value, 10);
	paraffinBlock.comment = frm.comment.value;
	submitInfo.paraffinBlock = paraffinBlock;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));

	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Creating HE glass plates...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=RegisterHEGlass';
		request.open("POST", url, false);
		request.setRequestHeader("Content-Type", "application/json");
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		var msgLine = response.messages[i];
		if (msgLine.indexOf('[Warning]') >= 0)
		{
			msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
		}
		else
		{
			msg += '<li>' + msgLine;
		}
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');

}

</script>
<style>
	div.paraffinblock
	{
		margin: 0em 1em 1em 1em;
	}
	
	div.paraffinblock > table
	{
		width: 100%;
		height: 4cm;
		border-collapse: collapse;
		border: 1px solid #A0A0A0;
		table-layout: fixed;
	}
	
	div.paraffinblock > table > tbody > tr > td
	{
		width: 50%;
		vertical-align: middle;
		border: 1px solid #A0A0A0;
		padding: 2px 2px 2px 1em;
	}

	#existingGlass img
	{
		float: left;
		margin: 0.5em;
	}

	#glassTable
	{
		width: 100%; 
		border-collapse: collapse;
	}
	
	#glassTable th
	{
		padding-left: 2px;
		padding-right: 2px;
		text-align: left;
	}
	
	#glassTable td
	{
		padding: 2px;
	}

</style>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register histology HE glass information" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select paraffin block</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table width="100%">
			<tr valign="top">
				<td class="prompt">Paraffin blocks</td>
				<td class="input"><select style="width:90%" name="plates" id="plates"></select>
				
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" onclick="selectParaffinBlocks()" id="btnSelectParaffinBlocks" />
					</base:buttongroup>
				</td>
				<td class="status" id="plates.status"></td>
				<td class="help"><span id="plates.message" class="message" style="display: none;"></span>
					The list contain all paraffin blocks with no child HEglass plates.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div id="step2" style="display: none;">
		<p>
		<table class="stepform">
		<tr>
			<td rowspan="3" class="stepno">2</td>
			<td class="steptitle">Enter index of best stained samples</td>
		</tr>
		<tr>
			<td class="stepfields">
	
				<table width="100%">
				<tr valign="top">
					<td class="prompt">Date</td>
					<td class="input">
						<input type="text" name="stainDate" value="<%=today%>" size="12" maxlength="10" 
							onblur="stainDateOnChange()">
					</td>
					<td class="status" id="stainDate.status"></td>
					<td class="help">
						<span id="stainDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Protocol</td>
					<td class="input"><select style="width:95%" name="stainingProtocol" id="stainingProtocol" 
						></select></td>
					<td class="status" id="stainingProtocol.status"></td>
					<td class="help"><span id="stainingProtocol.message" class="message" style="display: none;"></span>
						Select the protocol which was used for staining.
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Paraffin block</td>
					<td class="input"><span id="blockName"></span></td>
					<td class="status" id="paraffinblock.status"></td>
					<td class="help"></td>
				</tr>
				<tr valign="top">
					<td class="subprompt">- comment</td>
					<td class="input"><textarea name="comment" rows="2" style="width: 95%;"></textarea></td>
					<td class="status" id="comment.status"></td>
					<td class="help"></td>
				</tr>
				<tr valign="top">
					<td class="prompt">HE slides created</td>
					<td class="input"><input type="text" size="4"
						name="numberOfHEGlass" value="2" 
						onblur="checkNumHEGlass()"
						onkeypress="focusOnEnter(event, 'idx.0.0'); return Numbers.integerOnly(event)">
					</td>
					<td class="status" id="numberOfHEGlass.status"></td>
					<td class="help"><span id="numberOfHEGlass.message" class="message" style="display: none;"></span>
						Enter the total number of HE glass slides that has been created from the selected paraffin block.
					</td>
				</tr>
				
				<tr valign="top">
					<td colspan="2">
					<div class="paraffinblock">
						<table>
						<tr>
							<td>
								<b>3</b>: <span id="his.0.0"><i>empty</i></span>
								<input type="text" name="idx.0.0" 
									onblur="checkIndexValue('idx.0.0')"
									onkeypress="focusOnEnter(event, 'idx.1.0');return Numbers.integerOnly(event)" size="2">
								<span id="idx.0.0.status" class="status"></span>
							</td>
							<td>
							</td>
						</tr>
						<tr>
							<td>
								<b>2</b>: <span id="his.1.0"><i>empty</i></span>
								<input type="text" name="idx.1.0" 
									onblur="checkIndexValue('idx.1.0')"
									onkeypress="focusOnEnter(event, 'idx.1.1');return Numbers.integerOnly(event)" size="2">
								<span id="idx.1.0.status" class="status"></span>
							</td>
							<td>
								<b>5</b>: <span id="his.1.1"><i>empty</i></span>
								<input type="text" name="idx.1.1" 
									onblur="checkIndexValue('idx.1.1')"
									onkeypress="focusOnEnter(event, 'idx.2.0');return Numbers.integerOnly(event)" size="2">
								<span id="idx.1.1.status" class="status"></span>
							</td>
						</tr>
						<tr>
							<td>
								<b>1</b>: <span id="his.2.0"><i>empty</i></span>
								<input type="text" name="idx.2.0" 
									onblur="checkIndexValue('idx.2.0')"
									onkeypress="focusOnEnter(event, 'idx.2.1');return Numbers.integerOnly(event)" size="2">
								<span id="idx.2.0.status" class="status"></span>
							</td>
							<td>
								<b>4</b>: <span id="his.2.1"><i>empty</i></span>
								<input type="text" name="idx.2.1" 
									onblur="checkIndexValue('idx.2.1')"
									onkeypress="return Numbers.integerOnly(event)" size="2">
								<span id="idx.2.1.status" class="status"></span>
							</td>
							</tr>
						</table>
						<div id="existingGlass" class="messagecontainer note" style="display:none;"></div>
					</div>

					</td>
					<td class="status" id="index.status"></td>
					<td class="help"><span id="index.message" class="message" style="display: none;"></span>
						Enter the index number (starting at 1) of the HE glass that 
						contains the best stain for each sample. HE glass plates are created
						with names HE<i>nnnnn</i>.1, HE<i>nnnnn</i>.2, etc. where <i>nnnnn</i> 
						is the number from the paraffin block name.
					</td>
				</tr>
				</table>
			</td>
		</tr>
		
		</table>
	</div>
	
	<div id="glassBoxSection" style="display:none;">
		<table class="stepform">
		<tr>
			<td rowspan="3" class="stepno">3</td>
			<td class="steptitle">Storage location for HE glass</td>
		</tr>
		<tr>
			<td class="stepfields">
				<table style="width: 100%;">
				<tr valign="top">
					<td class="input" style="width: 480px;">
						<div id="glassBoxInput"></div>
					</td>
					<td class="help"><span id="glassBox.message" class="message" style="display: none;"></span>
						Enter the box number/name and position in which the HE glass are stored.
						Changes are automatically propagated downwards.
					</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>