<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	
<script language="JavaScript">
var debug = false;
var rnaQcBioPlates = null
var runParameterConfigurations = null;

function init()
{
	var frm = document.forms['reggie'];

	try
	{
		showLoadingAnimation('Loading RNAQC bioplates...');
		getActiveRnaQcBioPlates();
		for (var i = 0; i < rnaQcBioPlates.length; i++)
		{
			var plate = rnaQcBioPlates[i];
			if (plate.usedWells > 0)
			{
				
				frm.bioPlates[frm.bioPlates.length] = new Option(plate.name + ' -- ' + plate.usedWells + ' used wells', plate.id);
			}
		}
		
		if (frm.bioPlates.length == 0)
		{
			var msg = 'Could not find any bioplates to export.';
			setFatalError(msg);
		}
		
		getConfigurationsForRunParametersExporter();
		var exportHtml = makeButton('Sample names (csv)', "goExport('SAMPLE_NAMES')");
		for (var i = 0; i < runParameterConfigurations.length; i++)
		{
			var config = runParameterConfigurations[i];
			exportHtml += makeButton('Run parameters: '+config.name + ' (xml)', "goExport('"+config.id+"')");
		}
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	setInnerHTML('export', exportHtml);
}


function makeButton(title, onClick)
{
	var btn = '';
	btn += '<span class="link" onclick="'+onClick+'">';
	btn += '<img src="../images/export.png">&nbsp;';
	btn += title+'</span><br>\n';
	return btn;
}

function getConfigurationsForRunParametersExporter()
{
	var request = Ajax.getXmlHttpRequest();
	var url = '../RnaQc.servlet?ID=<%=ID%>&cmd=GetConfigurationsForRunParametersExporter';		
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	runParameterConfigurations = response.configurations;
}

function getActiveRnaQcBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	var url = '../RnaQc.servlet?ID=<%=ID%>&cmd=GetActiveRnaQcBioPlates&numFreeWells=0&bioPlateType=CALIPER_RNAQC';		
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	rnaQcBioPlates = response.plates;
}


function goExport(exporter)
{
	var frm = document.forms['reggie'];	
	var bioPlateId = frm.bioPlates[frm.bioPlates.selectedIndex].value;
	
	var url;
	if (exporter == 'SAMPLE_NAMES')
	{
		url = '../RnaQc.servlet?ID=<%=ID%>&cmd=ExportSampleNamesForCaliper&bioPlateId='+bioPlateId;
	}
	else
	{
		url = '../RnaQc.servlet?ID=<%=ID%>&cmd=ExportRunParameters&bioPlateId='+bioPlateId+'&configurationId='+exporter;
	}
	window.location = url;
}

</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="RNA quality control - Export Caliper sample names and run parameters" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the export but 
			you may not be able to see all items.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Select bioplate -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">1</td>
		<td class="steptitle">Select bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Active bioplates</td>
				<td class="input">
					<select style="width:90%" name="bioPlates" id="bioPlates" onkeypress='doOnTab(event, goNextAuto)'></select>
				</td>
				<td class="status" id="bioplates.status"></td>
				<td class="help"><span id="bioplates.message" class="message" style="display: none;"></span>
					Select the bioplate to export sample names or run parameters from. 
					<p>
					The list contain RNAQC bioplates without quality score data (determined by 
					absence of QCRunDate annotation).
					<p>
					Tip! You can run the exporter for any bioplate as a regular plug-in by selecting 
					a bioplate from the list at <a 
					href="<%=request.getContextPath()%>/biomaterials/bioplates/index.jsp?ID=<%=ID%>"
					>Biomaterial LIMS › Bioplates</a> and then use the <b>Export</b> button. 
				</td>
			</tr>
			
			<tr valign="top">
				<td class="prompt">Export</td>
				<td class="input" id="export" style="white-space: nowrap;">
					
				</td>
				<td class="status" id="export.status"></td>
				<td class="help"><span id="export.message" class="message" style="display: none;"></span>
					Select what to export. Typically, you'll need the sample name file and the standard and
					high sensitivity run files.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>