<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String title = "Options for auto-selecting RNA";
%>
<base:page type="popup" title="<%=title%>">
<base:head>
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script>
function autoSelect()
{
	var options = {};
	var frm = document.forms['options'];
	
	var startDate = frm.startDate.value;
	if (startDate && !Dates.isDate(startDate, 'yyyyMMdd'))
	{
		frm.startDate.focus();
		alert('Not a valid date: ' + startDate);
		return;
	}
	
	var qRegular = parseFloat(frm.quantity_regular.value);
	if (!(qRegular > 0))
	{
		frm.quantity_regular.focus();
		alert('Remaining quantity must be a number >0');
		return;
	}
	
	var qualityScore = parseFloat(frm.quality_score.value);
	if (!(qualityScore > 0))
	{
		frm.quality_score.focus();
		alert('RQS/RIN must be a number >0')
		return;
	}
	
	if (startDate) options.startDate = startDate;
	if (frm.remainingQuantity.checked) options.remainingQuantity = qRegular;
	if (frm.qualityScore.checked) options.qualityScore = qualityScore;
	if (frm.flag.checked) options.flag = 1;
	if (frm.reProcess.checked) options.reProcess = 1;
	try
	{
		showLoadingAnimation('Finding RNA. Please wait...');
		var msg = window.opener.autoSelect(options);
		if (msg) alert(msg);
		window.close();
	}
	finally
	{
		hideLoadingAnimation();
	}
}

function init()
{
	var frm = window.opener.document.forms['reggie'];
	var opt = document.forms['options'];
	var qRegular = parseFloat(frm.quantity_regular.value);
	if (qRegular > 0) 
	{
		opt.quantity_regular.value = qRegular;
	}
}

function setStartDate(frmName, dateField, date)
{
	var frm = document.forms[frmName];
	frm[dateField].value = date;
	frm[dateField].focus();
}

</script>
<style>
div#loading
{
	text-align: center; 
	margin-top: 2em;
}
</style>
</base:head>
<base:body onload="init()">
	<h1><%=title %></h1>

	<form name="options" onsubmit="return false;">

	<div class="content bottomborder">
	
		<table class="fullform input100">
		<tr>
			<th>Start date</th>
			<td>
				<input type="text" name="startDate" value="" style="width: 12em;" maxlength="10"
					title="Enter start date in YYYYMMDD format">
					<base:icon 
						onclick="Dates.selectDate('Start date', 'options', 'startDate', 'setStartDate', 'yyyyMMdd')"
						image="calendar.png" 
						tooltip="Select a date from a calendar" 
						tabindex="-1"
					/> (empty = start from oldest)
			</td>
		</tr>
		<tr valign="top">
			<th>Active filters</th>
			<td>
				<input type="checkbox" name="remainingQuantity" id="remainingQuantity" value="1" checked>
					<label for="remainingQuantity">Remaining quantity</label> ≥ 
						<input type="text" class="text required" name="quantity_regular" style="width: 4em;"
							onkeypress="return Numbers.numberOnly(event)" 
							value="1.1"> µg<br>
				<input type="checkbox" name="qualityScore" id="qualityScore" value="1" checked>
					<label for="qualityScore">RQS/RIN</label> ≥ 
						<input type="text" class="text required" name="quality_score" style="width: 4em;"
							onkeypress="return Numbers.numberOnly(event)" 
							value="6"><br>
			</td>
		</tr>
		<tr>
			<th>Re-process</th>
			<td>
				<input type="checkbox" name="reProcess" id="reProcess" value="1" checked><label for="reProcess">Select RNA marked for re-process</label> (even if filter doesn't match)
			</td>
		</tr>
		<tr>
			<th>Flag</th>
			<td>
				<input type="checkbox" name="flag" id="flag" value="1" checked><label for="flag">Flag RNA not matching the filter</label>
			</td>
		</tr>
		<tr class="dynamic">
			<th></th>
			<td>
				<div class="loading" id="loading" style="display: none;">
				<table>
				<tr>
					<td><img src="../images/loading.gif"></td>
					<td id="loading.msg">Please wait...</td>
				</tr>
				</table>
			</div>
				
			</td>
		</tr>
		</table>
	
	</div>
	</form>
	
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button onclick="autoSelect()" title="Ok" />
		<base:button onclick="window.close()" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>